<template>
  <q-toolbar class="bg-primary text-white raised" role="region" aria-label="Lijst">
    <q-toolbar-title role="heading">Concepten
      <q-badge outline align="top">{{ filtered_concepts.length }}</q-badge>
    </q-toolbar-title>
  </q-toolbar>
  <q-card>
    <q-card-section>
      <q-input label="zoek" v-model="search_value" autofocus tabindex="0" title="Filter lijst">
        <template v-slot:prepend>
          <q-icon name="search"/>
        </template>
      </q-input>
    </q-card-section>
  </q-card>
  <q-expansion-item icon="filter_alt" label="Filters" tabindex="0" title="Filters" ref="filter_list"
                    q-aria-label="ShowHide filters">
    <q-card role="region" aria-label="Filters">
      <q-card-section>
        <q-radio v-model="f_link" val="_all" label="All" tabindex="0" title="Alle concepten"
                 @update:model-value="filter_list.hide()"/>
        <br>
        <q-radio v-model="f_link" val="p_link" label="Presentation" tabindex="0"
                 title="Concepten gebruikt in de presentatie" @update:model-value="filter_list.hide()"/>
        <br>
        <q-radio v-model="f_link" val="d_link" label="Definition" tabindex="0"
                 title="Concepten gebruiktin de definitie" @update:model-value="filter_list.hide()"/>
      </q-card-section>
      <q-card-section>
        <q-radio v-model="f_abstract" val="true" label="Abstract" tabindex="0" title="Abstracte concepten"
                 @update:model-value="filter_list.hide()"/>
        <br>
        <q-radio v-model="f_abstract" val="false" label="Reportable item" tabindex="0" title="Reportable items"
                 @update:model-value="filter_list.hide()"/>
        <br>
        <q-radio v-model="f_abstract" val="_all" label="All" tabindex="0" title="Alle concepten"
                 @update:model-value="filter_list.hide()"/>
      </q-card-section>
      <q-card-section>
        <q-select name="select_datatype" label="datatype" v-model="f_data_type" :options="get_data_types" tabindex="0"
                  title="Datatype" @update:model-value="filter_list.hide()">

        </q-select>
      </q-card-section>
      <q-card-section>
        <q-select name="select_substitution" label="substitution group" v-model="f_substitution_group" tabindex="0"
                  title="Substitutiegroep"
                  :options="get_substitution_groups" @update:model-value="filter_list.hide()"></q-select>
      </q-card-section>
    </q-card>
  </q-expansion-item>

  <div>
    <q-virtual-scroll :items="filtered_concepts" role="region" aria-label="Lijst concepten"
                      virtual-scroll-slice-size="60" bordered virtual-scroll-item-size="48" class="scroll_list">
      <template v-slot="{ item }">
        <q-item clickable v-ripple
                v-bind:id="item.id"
                v-bind:key="item.id"
                @click="show_detail(item)"
                active-class="active"
                title="Klik voor details"
                tabindex="0"
                class="conceptlist-item"
                :class="class_for_concept(item)">
          {{ item.name }}
        </q-item>
      </template>
    </q-virtual-scroll>
    <q-inner-loading :showing="typeof this.concepts=='undefined'">
      <q-circular-progress
        class="text-blue-grey"
        indeterminate
        size="50px"
        :thickness="0.22"
        v-if="typeof this.concepts=='undefined'"></q-circular-progress>
    </q-inner-loading>

  </div>
</template>

<script>
import {api} from 'boot/axios'
import {ref} from 'vue'
import _ from 'lodash';

export default {
  name: "ConceptList",
  setup() {
    return {f_abstract: ref("_all"), f_link: ref("_all"), filter_list: ref(null)}
  },
  computed: {
    filtered_concepts() {
      if (typeof (this.concepts) !== 'undefined') {
        let filtered = this.concepts
        if (this.f_abstract !== '_all') {
          if (this.f_abstract === "true") {
            filtered = filtered.filter(concept => concept.abstract === true)
          } else {
            filtered = filtered.filter(concept => concept.abstract === false)
          }
        }
        if (this.f_link !== '_all') {
          if (this.f_link === "p_link") {
            filtered = filtered.filter(concept => concept.p_link === true)
          } else {
            filtered = filtered.filter(concept => concept.d_link === true)
          }
        }
        if (this.f_data_type !== '') {
          filtered = filtered.filter(concept => concept.itemtype_name === this.f_data_type)
        }
        if (this.f_substitution_group !== '') {
          filtered = filtered.filter(concept => concept.substitution_group === this.f_substitution_group)
        }
        if (typeof (this.search_value) !== 'undefined' && this.search_value.length > 1) {
          filtered = filtered.filter(concept => concept.name.toLowerCase().includes(this.search_value.toLowerCase()))
        }
        return this.ordered_by_name(filtered)
      } else {
        return this.ordered_by_name(this.concepts)
      }
    },
    get_data_types() {
      if (typeof (this.concepts) !== 'undefined') {
        let datatypes = ['']
        this.concepts.forEach(concept => datatypes.push(concept.itemtype_name))
        return _.uniq(datatypes)
      } else {
        return []
      }
    },
    get_substitution_groups() {
      if (typeof (this.concepts) !== 'undefined') {
        let substitution_groups = ['']
        this.concepts.forEach(concept => {
          if (concept.substitution_group) {
            substitution_groups.push(concept.substitution_group)
          }
        })
        return _.orderBy(_.uniq(substitution_groups))
      } else {
        return []
      }
    }
  },
  created() {
    this.fetchData()
  },
  data() {
    return {
      concepts: undefined,
      current_concept: undefined,
      search_value: undefined,
      f_data_type: '',
      f_substitution_group: '',
    }
  },
  props: {
    dts_name: String,
    nt_version: String
  },
  methods: {
    fetchData: function () {
      if (this.dts_name) {
        api
          .get("/dts/" + this.dts_name + "/concepts",
            {params: {nt_version: this.nt_version, full: 0}})
          .then(response => {
            this.concepts = response.data
            if (this.concepts.length && (this.$route.fullPath.endsWith('/concepts') || this.$route.fullPath.endsWith('/concepts?lang=en'))) {
              this.$router.push({
                name: 'concept_detail',
                replace: true,
                params: {concept_id: this.filtered_concepts[0].id}
              })
            } else {
              this.$nextTick(() => {
                this.scroll_to_active()
              })
            }
          })
      }
    },
    show_detail: function (concept) {
      this.current_concept = concept
      this.$router.push({
        name: 'concept_detail',
        params: {concept_id: concept.id, dts_name: this.dts_name, nt_version: this.nt_version}
      })
    },
    class_for_concept: function (concept) {
      let classes = ""
      if (this.current_concept && this.current_concept.id === concept.id) {
        classes = "active "
      }
      if (concept.substitution_group) {
        return classes + concept.substitution_group.replace(':', '-')
      } else if (!concept.abstract) {
        return classes + 'concrete-item'
      } else {
        return classes + 'no-substitution'
      }
    },
    ordered_by_name: function (concepts) {
      return _.orderBy(concepts, 'name')
    },
    scroll_to_active: function () {
      let activelist = document.getElementsByClassName('active')
      if (activelist.length) {
        let el = activelist[0]
        let offset = el.getBoundingClientRect().top - window.scrollY - 100
        if (offset > window.innerHeight || offset < 0) {
          this.$nextTick(() => {
              el.scrollIntoView(true)
            }
          )
        }
      }
    }
  }
}
</script>

<style scoped lang="scss">
.scroll_list {
  overflow-y: auto;
  height: calc(100vh - 340px);
}

.active {
  background: $primary !important;
  color: white;
  opacity: 0.9;
}

.conceptlist-item {
  margin-left: 2px;
  border-top: 2px solid white;
}

.xbrli-item {
  border-left: 10px solid $blue-grey;
  background-color: $blue-grey-1;
}

.concrete-item {
  border-left: 10px solid $lime;
  background-color: $lime-1;
}

.sbr-domainMemberItem,
.sbr-primaryDomainItem {
  border-left: 10px solid $green;
  background-color: $green-1;
}

.xbrldt-dimensionItem {
  border-left: 10px solid $green;
  background-color: $green-1;
}

.xbrldt-hypercubeItem {
  border-left: 10px solid $blue;
  background-color: $blue-1;
}

.sbr-presentationItem {
  border-left: 10px solid $teal;
  background-color: $teal-1;
}

.no-substitution {
  border-left: 10px solid transparent;
}
</style>
